blob: 03e56a27f69caf51b1fc8e39537ab415b2a3da16 [file] [log] [blame]
Stefano Briviod1f1b9c2018-03-06 22:16:27 +01001#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
Stefano Brivioa41c7892018-03-17 02:31:42 +01004# Check that route PMTU values match expectations, and that initial device MTU
5# values are assigned correctly
Stefano Briviod1f1b9c2018-03-06 22:16:27 +01006#
7# Tests currently implemented:
8#
Stefano Brivio5e844302018-03-17 02:31:44 +01009# - pmtu_vti4_exception
10# Set up vti tunnel on top of veth, with xfrm states and policies, in two
11# namespaces with matching endpoints. Check that route exception is not
12# created if link layer MTU is not exceeded, then exceed it and check that
13# exception is created with the expected PMTU. The approach described
14# below for IPv6 doesn't apply here, because, on IPv4, administrative MTU
15# changes alone won't affect PMTU
16#
Stefano Brivio36455bd2018-03-17 02:31:41 +010017# - pmtu_vti6_exception
Stefano Briviod1f1b9c2018-03-06 22:16:27 +010018# Set up vti6 tunnel on top of veth, with xfrm states and policies, in two
19# namespaces with matching endpoints. Check that route exception is
20# created by exceeding link layer MTU with ping to other endpoint. Then
21# decrease and increase MTU of tunnel, checking that route exception PMTU
22# changes accordingly
Stefano Brivioa41c7892018-03-17 02:31:42 +010023#
24# - pmtu_vti4_default_mtu
25# Set up vti4 tunnel on top of veth, in two namespaces with matching
26# endpoints. Check that MTU assigned to vti interface is the MTU of the
27# lower layer (veth) minus additional lower layer headers (zero, for veth)
28# minus IPv4 header length
Stefano Brivio35b49422018-03-17 02:31:43 +010029#
30# - pmtu_vti6_default_mtu
31# Same as above, for IPv6
Stefano Brivio719e1212018-03-17 02:31:45 +010032#
33# - pmtu_vti4_link_add_mtu
34# Set up vti4 interface passing MTU value at link creation, check MTU is
35# configured, and that link is not created with invalid MTU values
Stefano Brivio8b6022f2018-03-17 02:31:46 +010036#
37# - pmtu_vti6_link_add_mtu
38# Same as above, for IPv6
Stefano Brivio1fad59e2018-03-17 02:31:47 +010039#
40# - pmtu_vti6_link_change_mtu
41# Set up two dummy interfaces with different MTUs, create a vti6 tunnel
42# and check that configured MTU is used on link creation and changes, and
43# that MTU is properly calculated instead when MTU is not configured from
44# userspace
Stefano Briviod1f1b9c2018-03-06 22:16:27 +010045
Shuah Khan (Samsung OSG)57aefc72018-05-04 16:34:09 -060046# Kselftest framework requirement - SKIP code is 4.
47ksft_skip=4
48
Sabrina Dubrocac81c7012018-08-30 16:01:18 +020049# Some systems don't have a ping6 binary anymore
50which ping6 > /dev/null 2>&1 && ping6=$(which ping6) || ping6=$(which ping)
51
Stefano Brivio36455bd2018-03-17 02:31:41 +010052tests="
Stefano Brivio1fad59e2018-03-17 02:31:47 +010053 pmtu_vti6_exception vti6: PMTU exceptions
54 pmtu_vti4_exception vti4: PMTU exceptions
55 pmtu_vti4_default_mtu vti4: default MTU assignment
56 pmtu_vti6_default_mtu vti6: default MTU assignment
57 pmtu_vti4_link_add_mtu vti4: MTU setting on link creation
58 pmtu_vti6_link_add_mtu vti6: MTU setting on link creation
59 pmtu_vti6_link_change_mtu vti6: MTU changes on link changes"
Stefano Brivio36455bd2018-03-17 02:31:41 +010060
Stefano Briviod1f1b9c2018-03-06 22:16:27 +010061NS_A="ns-$(mktemp -u XXXXXX)"
62NS_B="ns-$(mktemp -u XXXXXX)"
63ns_a="ip netns exec ${NS_A}"
64ns_b="ip netns exec ${NS_B}"
65
Stefano Brivioa41c7892018-03-17 02:31:42 +010066veth4_a_addr="192.168.1.1"
67veth4_b_addr="192.168.1.2"
68veth4_mask="24"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +010069veth6_a_addr="fd00:1::a"
70veth6_b_addr="fd00:1::b"
71veth6_mask="64"
72
Stefano Brivioa41c7892018-03-17 02:31:42 +010073vti4_a_addr="192.168.2.1"
74vti4_b_addr="192.168.2.2"
75vti4_mask="24"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +010076vti6_a_addr="fd00:2::a"
77vti6_b_addr="fd00:2::b"
78vti6_mask="64"
79
Stefano Brivio1fad59e2018-03-17 02:31:47 +010080dummy6_0_addr="fc00:1000::0"
81dummy6_1_addr="fc00:1001::0"
82dummy6_mask="64"
83
Stefano Brivio36455bd2018-03-17 02:31:41 +010084cleanup_done=1
85err_buf=
86
87err() {
88 err_buf="${err_buf}${1}
89"
90}
91
92err_flush() {
93 echo -n "${err_buf}"
94 err_buf=
95}
96
Stefano Briviod1f1b9c2018-03-06 22:16:27 +010097setup_namespaces() {
Stefano Brivio380e29a2018-03-17 02:31:38 +010098 ip netns add ${NS_A} || return 1
Stefano Briviod1f1b9c2018-03-06 22:16:27 +010099 ip netns add ${NS_B}
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100100}
101
102setup_veth() {
Stefano Brivio380e29a2018-03-17 02:31:38 +0100103 ${ns_a} ip link add veth_a type veth peer name veth_b || return 1
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100104 ${ns_a} ip link set veth_b netns ${NS_B}
105
Stefano Brivioa41c7892018-03-17 02:31:42 +0100106 ${ns_a} ip addr add ${veth4_a_addr}/${veth4_mask} dev veth_a
107 ${ns_b} ip addr add ${veth4_b_addr}/${veth4_mask} dev veth_b
108
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100109 ${ns_a} ip addr add ${veth6_a_addr}/${veth6_mask} dev veth_a
110 ${ns_b} ip addr add ${veth6_b_addr}/${veth6_mask} dev veth_b
111
112 ${ns_a} ip link set veth_a up
113 ${ns_b} ip link set veth_b up
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100114}
115
Stefano Brivioa41c7892018-03-17 02:31:42 +0100116setup_vti() {
117 proto=${1}
118 veth_a_addr="${2}"
119 veth_b_addr="${3}"
120 vti_a_addr="${4}"
121 vti_b_addr="${5}"
122 vti_mask=${6}
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100123
Stefano Brivioa41c7892018-03-17 02:31:42 +0100124 [ ${proto} -eq 6 ] && vti_type="vti6" || vti_type="vti"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100125
Stefano Brivioa41c7892018-03-17 02:31:42 +0100126 ${ns_a} ip link add vti${proto}_a type ${vti_type} local ${veth_a_addr} remote ${veth_b_addr} key 10 || return 1
127 ${ns_b} ip link add vti${proto}_b type ${vti_type} local ${veth_b_addr} remote ${veth_a_addr} key 10
128
129 ${ns_a} ip addr add ${vti_a_addr}/${vti_mask} dev vti${proto}_a
130 ${ns_b} ip addr add ${vti_b_addr}/${vti_mask} dev vti${proto}_b
131
132 ${ns_a} ip link set vti${proto}_a up
133 ${ns_b} ip link set vti${proto}_b up
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100134
135 sleep 1
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100136}
137
Stefano Brivioa41c7892018-03-17 02:31:42 +0100138setup_vti4() {
139 setup_vti 4 ${veth4_a_addr} ${veth4_b_addr} ${vti4_a_addr} ${vti4_b_addr} ${vti4_mask}
140}
141
142setup_vti6() {
143 setup_vti 6 ${veth6_a_addr} ${veth6_b_addr} ${vti6_a_addr} ${vti6_b_addr} ${vti6_mask}
144}
145
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100146setup_xfrm() {
Stefano Brivio5e844302018-03-17 02:31:44 +0100147 proto=${1}
148 veth_a_addr="${2}"
149 veth_b_addr="${3}"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100150
Stefano Brivio5e844302018-03-17 02:31:44 +0100151 ${ns_a} ip -${proto} xfrm state add src ${veth_a_addr} dst ${veth_b_addr} spi 0x1000 proto esp aead "rfc4106(gcm(aes))" 0x0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f 128 mode tunnel || return 1
152 ${ns_a} ip -${proto} xfrm state add src ${veth_b_addr} dst ${veth_a_addr} spi 0x1001 proto esp aead "rfc4106(gcm(aes))" 0x0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f 128 mode tunnel
153 ${ns_a} ip -${proto} xfrm policy add dir out mark 10 tmpl src ${veth_a_addr} dst ${veth_b_addr} proto esp mode tunnel
154 ${ns_a} ip -${proto} xfrm policy add dir in mark 10 tmpl src ${veth_b_addr} dst ${veth_a_addr} proto esp mode tunnel
155
156 ${ns_b} ip -${proto} xfrm state add src ${veth_a_addr} dst ${veth_b_addr} spi 0x1000 proto esp aead "rfc4106(gcm(aes))" 0x0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f 128 mode tunnel
157 ${ns_b} ip -${proto} xfrm state add src ${veth_b_addr} dst ${veth_a_addr} spi 0x1001 proto esp aead "rfc4106(gcm(aes))" 0x0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f0f 128 mode tunnel
158 ${ns_b} ip -${proto} xfrm policy add dir out mark 10 tmpl src ${veth_b_addr} dst ${veth_a_addr} proto esp mode tunnel
159 ${ns_b} ip -${proto} xfrm policy add dir in mark 10 tmpl src ${veth_a_addr} dst ${veth_b_addr} proto esp mode tunnel
160}
161
162setup_xfrm4() {
163 setup_xfrm 4 ${veth4_a_addr} ${veth4_b_addr}
164}
165
166setup_xfrm6() {
167 setup_xfrm 6 ${veth6_a_addr} ${veth6_b_addr}
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100168}
169
170setup() {
Shuah Khan (Samsung OSG)57aefc72018-05-04 16:34:09 -0600171 [ "$(id -u)" -ne 0 ] && echo " need to run as root" && return $ksft_skip
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100172
Stefano Brivio36455bd2018-03-17 02:31:41 +0100173 cleanup_done=0
174 for arg do
175 eval setup_${arg} || { echo " ${arg} not supported"; return 1; }
176 done
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100177}
178
179cleanup() {
Stefano Brivio36455bd2018-03-17 02:31:41 +0100180 [ ${cleanup_done} -eq 1 ] && return
Sabrina Dubroca0a286af2018-09-17 15:30:06 +0200181 ip netns del ${NS_A} 2> /dev/null
182 ip netns del ${NS_B} 2> /dev/null
Stefano Brivio36455bd2018-03-17 02:31:41 +0100183 cleanup_done=1
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100184}
185
186mtu() {
187 ns_cmd="${1}"
188 dev="${2}"
189 mtu="${3}"
190
191 ${ns_cmd} ip link set dev ${dev} mtu ${mtu}
192}
193
Stefano Briviof2c929f2018-03-17 02:31:40 +0100194mtu_parse() {
195 input="${1}"
196
197 next=0
198 for i in ${input}; do
Sabrina Dubroca72ebddd2018-10-08 14:37:04 +0200199 [ ${next} -eq 1 -a "${i}" = "lock" ] && next=2 && continue
Stefano Briviof2c929f2018-03-17 02:31:40 +0100200 [ ${next} -eq 1 ] && echo "${i}" && return
Sabrina Dubroca72ebddd2018-10-08 14:37:04 +0200201 [ ${next} -eq 2 ] && echo "lock ${i}" && return
Stefano Briviof2c929f2018-03-17 02:31:40 +0100202 [ "${i}" = "mtu" ] && next=1
203 done
204}
205
Stefano Brivioa41c7892018-03-17 02:31:42 +0100206link_get() {
207 ns_cmd="${1}"
208 name="${2}"
209
210 ${ns_cmd} ip link show dev "${name}"
211}
212
213link_get_mtu() {
214 ns_cmd="${1}"
215 name="${2}"
216
217 mtu_parse "$(link_get "${ns_cmd}" ${name})"
218}
219
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100220route_get_dst_exception() {
Stefano Brivio822d2f82018-03-17 02:31:39 +0100221 ns_cmd="${1}"
222 dst="${2}"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100223
Stefano Brivio822d2f82018-03-17 02:31:39 +0100224 ${ns_cmd} ip route get "${dst}"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100225}
226
227route_get_dst_pmtu_from_exception() {
Stefano Brivio822d2f82018-03-17 02:31:39 +0100228 ns_cmd="${1}"
229 dst="${2}"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100230
Stefano Briviof2c929f2018-03-17 02:31:40 +0100231 mtu_parse "$(route_get_dst_exception "${ns_cmd}" ${dst})"
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100232}
233
Stefano Brivio1e0a72072018-10-08 14:37:03 +0200234check_pmtu_value() {
235 expected="${1}"
236 value="${2}"
237 event="${3}"
238
239 [ "${expected}" = "any" ] && [ -n "${value}" ] && return 0
240 [ "${value}" = "${expected}" ] && return 0
241 [ -z "${value}" ] && err " PMTU exception wasn't created after ${event}" && return 1
242 [ -z "${expected}" ] && err " PMTU exception shouldn't exist after ${event}" && return 1
243 err " found PMTU exception with incorrect MTU ${value}, expected ${expected}, after ${event}"
244 return 1
245}
246
Stefano Brivio5e844302018-03-17 02:31:44 +0100247test_pmtu_vti4_exception() {
248 setup namespaces veth vti4 xfrm4 || return 2
249
250 veth_mtu=1500
251 vti_mtu=$((veth_mtu - 20))
252
253 # SPI SN IV ICV pad length next header
254 esp_payload_rfc4106=$((vti_mtu - 4 - 4 - 8 - 16 - 1 - 1))
255 ping_payload=$((esp_payload_rfc4106 - 28))
256
257 mtu "${ns_a}" veth_a ${veth_mtu}
258 mtu "${ns_b}" veth_b ${veth_mtu}
259 mtu "${ns_a}" vti4_a ${vti_mtu}
260 mtu "${ns_b}" vti4_b ${vti_mtu}
261
262 # Send DF packet without exceeding link layer MTU, check that no
263 # exception is created
264 ${ns_a} ping -q -M want -i 0.1 -w 2 -s ${ping_payload} ${vti4_b_addr} > /dev/null
265 pmtu="$(route_get_dst_pmtu_from_exception "${ns_a}" ${vti4_b_addr})"
Stefano Brivio1e0a72072018-10-08 14:37:03 +0200266 check_pmtu_value "" "${pmtu}" "sending packet smaller than PMTU (IP payload length ${esp_payload_rfc4106})" || return 1
Stefano Brivio5e844302018-03-17 02:31:44 +0100267
268 # Now exceed link layer MTU by one byte, check that exception is created
Stefano Brivio1e0a72072018-10-08 14:37:03 +0200269 # with the right PMTU value
Stefano Brivio5e844302018-03-17 02:31:44 +0100270 ${ns_a} ping -q -M want -i 0.1 -w 2 -s $((ping_payload + 1)) ${vti4_b_addr} > /dev/null
271 pmtu="$(route_get_dst_pmtu_from_exception "${ns_a}" ${vti4_b_addr})"
Stefano Brivio1e0a72072018-10-08 14:37:03 +0200272 check_pmtu_value "${esp_payload_rfc4106}" "${pmtu}" "exceeding PMTU (IP payload length $((esp_payload_rfc4106 + 1)))"
Stefano Brivio5e844302018-03-17 02:31:44 +0100273}
274
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100275test_pmtu_vti6_exception() {
Stefano Brivio5e844302018-03-17 02:31:44 +0100276 setup namespaces veth vti6 xfrm6 || return 2
Stefano Brivio36455bd2018-03-17 02:31:41 +0100277 fail=0
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100278
279 # Create route exception by exceeding link layer MTU
280 mtu "${ns_a}" veth_a 4000
281 mtu "${ns_b}" veth_b 4000
Stefano Brivioa41c7892018-03-17 02:31:42 +0100282 mtu "${ns_a}" vti6_a 5000
283 mtu "${ns_b}" vti6_b 5000
Sabrina Dubrocac81c7012018-08-30 16:01:18 +0200284 ${ns_a} ${ping6} -q -i 0.1 -w 2 -s 60000 ${vti6_b_addr} > /dev/null
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100285
286 # Check that exception was created
Stefano Brivio1e0a72072018-10-08 14:37:03 +0200287 pmtu="$(route_get_dst_pmtu_from_exception "${ns_a}" ${vti6_b_addr})"
288 check_pmtu_value any "${pmtu}" "creating tunnel exceeding link layer MTU" || return 1
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100289
290 # Decrease tunnel MTU, check for PMTU decrease in route exception
Stefano Brivioa41c7892018-03-17 02:31:42 +0100291 mtu "${ns_a}" vti6_a 3000
Stefano Brivio1e0a72072018-10-08 14:37:03 +0200292 pmtu="$(route_get_dst_pmtu_from_exception "${ns_a}" ${vti6_b_addr})"
293 check_pmtu_value "3000" "${pmtu}" "decreasing tunnel MTU" || fail=1
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100294
295 # Increase tunnel MTU, check for PMTU increase in route exception
Stefano Brivioa41c7892018-03-17 02:31:42 +0100296 mtu "${ns_a}" vti6_a 9000
Stefano Brivio1e0a72072018-10-08 14:37:03 +0200297 pmtu="$(route_get_dst_pmtu_from_exception "${ns_a}" ${vti6_b_addr})"
298 check_pmtu_value "9000" "${pmtu}" "increasing tunnel MTU" || fail=1
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100299
Stefano Brivio36455bd2018-03-17 02:31:41 +0100300 return ${fail}
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100301}
302
Stefano Brivioa41c7892018-03-17 02:31:42 +0100303test_pmtu_vti4_default_mtu() {
304 setup namespaces veth vti4 || return 2
305
306 # Check that MTU of vti device is MTU of veth minus IPv4 header length
307 veth_mtu="$(link_get_mtu "${ns_a}" veth_a)"
308 vti4_mtu="$(link_get_mtu "${ns_a}" vti4_a)"
309 if [ $((veth_mtu - vti4_mtu)) -ne 20 ]; then
310 err " vti MTU ${vti4_mtu} is not veth MTU ${veth_mtu} minus IPv4 header length"
311 return 1
312 fi
313}
314
Stefano Brivio35b49422018-03-17 02:31:43 +0100315test_pmtu_vti6_default_mtu() {
316 setup namespaces veth vti6 || return 2
317
318 # Check that MTU of vti device is MTU of veth minus IPv6 header length
319 veth_mtu="$(link_get_mtu "${ns_a}" veth_a)"
320 vti6_mtu="$(link_get_mtu "${ns_a}" vti6_a)"
321 if [ $((veth_mtu - vti6_mtu)) -ne 40 ]; then
322 err " vti MTU ${vti6_mtu} is not veth MTU ${veth_mtu} minus IPv6 header length"
323 return 1
324 fi
325}
326
Stefano Brivio719e1212018-03-17 02:31:45 +0100327test_pmtu_vti4_link_add_mtu() {
328 setup namespaces || return 2
329
330 ${ns_a} ip link add vti4_a type vti local ${veth4_a_addr} remote ${veth4_b_addr} key 10
331 [ $? -ne 0 ] && err " vti not supported" && return 2
332 ${ns_a} ip link del vti4_a
333
334 fail=0
335
336 min=68
Sabrina Dubroca902b5412018-08-30 16:01:17 +0200337 max=$((65535 - 20))
Stefano Brivio719e1212018-03-17 02:31:45 +0100338 # Check invalid values first
339 for v in $((min - 1)) $((max + 1)); do
340 ${ns_a} ip link add vti4_a mtu ${v} type vti local ${veth4_a_addr} remote ${veth4_b_addr} key 10 2>/dev/null
341 # This can fail, or MTU can be adjusted to a proper value
342 [ $? -ne 0 ] && continue
343 mtu="$(link_get_mtu "${ns_a}" vti4_a)"
344 if [ ${mtu} -lt ${min} -o ${mtu} -gt ${max} ]; then
345 err " vti tunnel created with invalid MTU ${mtu}"
346 fail=1
347 fi
348 ${ns_a} ip link del vti4_a
349 done
350
351 # Now check valid values
352 for v in ${min} 1300 ${max}; do
353 ${ns_a} ip link add vti4_a mtu ${v} type vti local ${veth4_a_addr} remote ${veth4_b_addr} key 10
354 mtu="$(link_get_mtu "${ns_a}" vti4_a)"
355 ${ns_a} ip link del vti4_a
356 if [ "${mtu}" != "${v}" ]; then
357 err " vti MTU ${mtu} doesn't match configured value ${v}"
358 fail=1
359 fi
360 done
361
362 return ${fail}
363}
364
Stefano Brivio8b6022f2018-03-17 02:31:46 +0100365test_pmtu_vti6_link_add_mtu() {
366 setup namespaces || return 2
367
368 ${ns_a} ip link add vti6_a type vti6 local ${veth6_a_addr} remote ${veth6_b_addr} key 10
369 [ $? -ne 0 ] && err " vti6 not supported" && return 2
370 ${ns_a} ip link del vti6_a
371
372 fail=0
373
Stefano Brivio5a643c82018-04-26 19:41:02 +0200374 min=68 # vti6 can carry IPv4 packets too
Stefano Brivio8b6022f2018-03-17 02:31:46 +0100375 max=$((65535 - 40))
376 # Check invalid values first
377 for v in $((min - 1)) $((max + 1)); do
378 ${ns_a} ip link add vti6_a mtu ${v} type vti6 local ${veth6_a_addr} remote ${veth6_b_addr} key 10 2>/dev/null
379 # This can fail, or MTU can be adjusted to a proper value
380 [ $? -ne 0 ] && continue
381 mtu="$(link_get_mtu "${ns_a}" vti6_a)"
382 if [ ${mtu} -lt ${min} -o ${mtu} -gt ${max} ]; then
383 err " vti6 tunnel created with invalid MTU ${v}"
384 fail=1
385 fi
386 ${ns_a} ip link del vti6_a
387 done
388
389 # Now check valid values
Stefano Brivio5a643c82018-04-26 19:41:02 +0200390 for v in 68 1280 1300 $((65535 - 40)); do
Stefano Brivio8b6022f2018-03-17 02:31:46 +0100391 ${ns_a} ip link add vti6_a mtu ${v} type vti6 local ${veth6_a_addr} remote ${veth6_b_addr} key 10
392 mtu="$(link_get_mtu "${ns_a}" vti6_a)"
393 ${ns_a} ip link del vti6_a
394 if [ "${mtu}" != "${v}" ]; then
395 err " vti6 MTU ${mtu} doesn't match configured value ${v}"
396 fail=1
397 fi
398 done
399
400 return ${fail}
401}
402
Stefano Brivio1fad59e2018-03-17 02:31:47 +0100403test_pmtu_vti6_link_change_mtu() {
404 setup namespaces || return 2
405
406 ${ns_a} ip link add dummy0 mtu 1500 type dummy
407 [ $? -ne 0 ] && err " dummy not supported" && return 2
408 ${ns_a} ip link add dummy1 mtu 3000 type dummy
409 ${ns_a} ip link set dummy0 up
410 ${ns_a} ip link set dummy1 up
411
412 ${ns_a} ip addr add ${dummy6_0_addr}/${dummy6_mask} dev dummy0
413 ${ns_a} ip addr add ${dummy6_1_addr}/${dummy6_mask} dev dummy1
414
415 fail=0
416
417 # Create vti6 interface bound to device, passing MTU, check it
418 ${ns_a} ip link add vti6_a mtu 1300 type vti6 remote ${dummy6_0_addr} local ${dummy6_0_addr}
419 mtu="$(link_get_mtu "${ns_a}" vti6_a)"
420 if [ ${mtu} -ne 1300 ]; then
421 err " vti6 MTU ${mtu} doesn't match configured value 1300"
422 fail=1
423 fi
424
425 # Move to another device with different MTU, without passing MTU, check
426 # MTU is adjusted
Stefano Brivio1fad59e2018-03-17 02:31:47 +0100427 ${ns_a} ip link set vti6_a type vti6 remote ${dummy6_1_addr} local ${dummy6_1_addr}
428 mtu="$(link_get_mtu "${ns_a}" vti6_a)"
429 if [ ${mtu} -ne $((3000 - 40)) ]; then
430 err " vti MTU ${mtu} is not dummy MTU 3000 minus IPv6 header length"
431 fail=1
432 fi
433
434 # Move it back, passing MTU, check MTU is not overridden
Stefano Brivio1fad59e2018-03-17 02:31:47 +0100435 ${ns_a} ip link set vti6_a mtu 1280 type vti6 remote ${dummy6_0_addr} local ${dummy6_0_addr}
436 mtu="$(link_get_mtu "${ns_a}" vti6_a)"
437 if [ ${mtu} -ne 1280 ]; then
438 err " vti6 MTU ${mtu} doesn't match configured value 1280"
439 fail=1
440 fi
441
442 return ${fail}
443}
444
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100445trap cleanup EXIT
446
Stefano Brivio36455bd2018-03-17 02:31:41 +0100447exitcode=0
448desc=0
449IFS="
450"
451for t in ${tests}; do
452 [ $desc -eq 0 ] && name="${t}" && desc=1 && continue || desc=0
Stefano Briviod1f1b9c2018-03-06 22:16:27 +0100453
Stefano Brivio36455bd2018-03-17 02:31:41 +0100454 (
455 unset IFS
456 eval test_${name}
457 ret=$?
458 cleanup
459
460 if [ $ret -eq 0 ]; then
461 printf "TEST: %-60s [ OK ]\n" "${t}"
462 elif [ $ret -eq 1 ]; then
463 printf "TEST: %-60s [FAIL]\n" "${t}"
464 err_flush
465 exit 1
466 elif [ $ret -eq 2 ]; then
467 printf "TEST: %-60s [SKIP]\n" "${t}"
468 err_flush
469 fi
470 )
471 [ $? -ne 0 ] && exitcode=1
472done
473
474exit ${exitcode}